import enum
from enum import Enum


class Locality(Enum):
    CN = 'CN'
    USA = 'USA'
    KR = 'KR'
    RU = 'RU'
    GER = 'GER'


API_DOMAIN = {
    Locality.CN: 'open-cn.aqara.com',
    Locality.USA: 'open-usa.aqara.com',
    Locality.KR: 'open-kr.aqara.com',
    Locality.RU: 'open-ru.aqara.com',
    Locality.GER: 'open-ger.aqara.com',
}  # type: dict[Locality, str]


class ErrorCode(enum.Enum):
    CODE_SUCCESS = 0  # Success
    CODE_100 = 100  # Timeout
    CODE_101 = 101  # Invalid data package
    CODE_102 = 102  # Data package has altered
    CODE_103 = 103  # Data package may lose
    CODE_104 = 104  # Server busy
    CODE_105 = 105  # Data package has expired
    CODE_106 = 106  # Invalid sign
    CODE_107 = 107  # Illegal appKey
    CODE_108 = 108  # Token has expired
    CODE_109 = 109  # Token is absence
    CODE_302 = 302  # Params error
    CODE_303 = 303  # Request params type error
    CODE_304 = 304  # Request method not support
    CODE_305 = 305  # Header Params error
    CODE_306 = 306  # Request path not open
    CODE_403 = 403  # Request forbidden
    CODE_429 = 429  # Too Many Requests
    CODE_500 = 500  # Service impl error
    CODE_501 = 501  # Service proxy error
    CODE_601 = 601  # Device not register
    CODE_602 = 602  # Device is offline
    CODE_603 = 603  # Device permission denied
    CODE_604 = 604  # Illegal device id
    CODE_605 = 605  # Device info inconsistent
    CODE_606 = 606  # Device request not support
    CODE_607 = 607  # Gateway has been bind
    CODE_608 = 608  # Sub device bind error
    CODE_609 = 609  # Gateway unbind error
    CODE_610 = 610  # Subdevice unbind error
    CODE_611 = 611  # Subdevice not bind
    CODE_612 = 612  # Gateway request not response
    CODE_615 = 615  # Not find parent device
    CODE_636 = 636  # BindKey time out
    CODE_637 = 637  # Irid not exists
    CODE_638 = 638  # Sub device not support this operation
    CODE_639 = 639  # Device cannot mount sub device
    CODE_640 = 640  # Device five code not found
    CODE_641 = 641  # Bluetooth device operate with wrong step
    CODE_642 = 642  # Bluetooth device validate wrong
    CODE_643 = 643  # Bluetooth info not exist
    CODE_644 = 644  # Failed validate security code
    CODE_645 = 645  # App bluetooth device register wrong step
    CODE_651 = 651  # Gateway not exists
    CODE_652 = 652  # Gateway limit
    CODE_655 = 655  # dynamic sequence run failed
    CODE_656 = 656  # Device not allow bind
    CODE_657 = 657  # Device group config exist
    CODE_658 = 658  # This ir device not support copy
    CODE_664 = 664  # Device function not support
    CODE_701 = 701  # Position not exist
    CODE_702 = 702  # Position cannot deleted
    CODE_703 = 703  # Position name duplication
    CODE_704 = 704  # Default position create duplication
    CODE_705 = 705  # Device name duplication
    CODE_706 = 706  # Device permission denied
    CODE_707 = 707  # Ifttt permission denied
    CODE_708 = 708  # Scene permission denied
    CODE_709 = 709  # Service permission denied
    CODE_710 = 710  # Position permission denied
    CODE_712 = 712  # Parent position error
    CODE_713 = 713  # Position not real position
    CODE_714 = 714  # Position is not allowed to be deleted
    CODE_715 = 715  # Position error
    CODE_716 = 716  # Scene not exist
    CODE_717 = 717  # Device does not belong to this user
    CODE_718 = 718  # Data error
    CODE_719 = 719  # Device no bind user
    CODE_722 = 722  # Out of position layer
    CODE_726 = 726  # Device size beyond
    CODE_727 = 727  # Position size beyond
    CODE_728 = 728  # Start or end time cannot be empty
    CODE_729 = 729  # The start time must not be greater than the end time
    CODE_730 = 730  # Start or end time not a timestamp
    CODE_731 = 731  # Ifttt not exists
    CODE_745 = 745  # BindKey not exists
    CODE_746 = 746  # Gateway not connect cloud
    CODE_747 = 747  # Device unsupported
    CODE_748 = 748  # Category model not exists
    CODE_749 = 749  # Custom Action name duplicate
    CODE_750 = 750  # Ircode key not exists
    CODE_751 = 751  # BindKey has been used
    CODE_753 = 753  # ir device limit
    CODE_754 = 754  # Custom Action not exist
    CODE_755 = 755  # subject permission denied
    CODE_756 = 756  # no permissions
    CODE_757 = 757  # Device not bind user
    CODE_758 = 758  # Param length limit
    CODE_760 = 760  # Action not support
    CODE_763 = 763  # Trigger not support
    CODE_768 = 768  # Ifttt name has exists
    CODE_769 = 769  # Scene name has exists
    CODE_770 = 770  # Device name has exists
    CODE_778 = 778  # The device can not unbind
    CODE_788 = 788  # Condition event Permission denied
    CODE_789 = 789  # Condition event duplicate name
    CODE_801 = 801  # Account not register
    CODE_802 = 802  # Account not login
    CODE_803 = 803  # User permission denied
    CODE_804 = 804  # Token failed
    CODE_805 = 805  # Account has register
    CODE_807 = 807  # Account format error
    CODE_810 = 810  # Password incorrect
    CODE_811 = 811  # AuthCode incorrect
    CODE_812 = 812  # Account type unsupport
    CODE_816 = 816  # AuthCode incorrect
    CODE_817 = 817  # AuthCode send all too often
    CODE_820 = 820  # AuthCode is invalid
    CODE_901 = 901  # Upgrade error
    CODE_902 = 902  # Firmware not exist
    CODE_903 = 903  # Package not exist
    CODE_904 = 904  # Firmware already up to date
    CODE_905 = 905  # Firmware query is empty
    CODE_906 = 906  # No updatable firmware
    CODE_907 = 907  # firmware upgrade failed
    CODE_908 = 908  # Device is being upgrade
    CODE_909 = 909  # The sub device's gateway is being upgraded
    CODE_910 = 910  # The gateway's sub device are being upgraded
    CODE_911 = 911  # The sub device's gateway is also upgraded
    CODE_912 = 912  # Model can't be upgraded with firmware
    CODE_1003 = 1003  # Resource attr illegal
    CODE_1004 = 1004  # Resource value illegal
    CODE_1006 = 1006  # Subject type not support
    CODE_1007 = 1007  # Resource write not support
    CODE_1008 = 1008  # Resource attr not exist
    CODE_1009 = 1009  # Report attr error
    CODE_1010 = 1010  # Report resourceId error
    CODE_1201 = 1201  # Linkage not exist
    CODE_1202 = 1202  # Scene not exist
    CODE_1203 = 1203  # Ifttt execute condition not satisfied
    CODE_1204 = 1204  # linkage no device
    CODE_1205 = 1205  # Scene no device
    CODE_1206 = 1206  # Delete local linkage failed
    CODE_1207 = 1207  # Operation failed
    CODE_1208 = 1208  # Ifttt parameter error
    CODE_1210 = 1210  # This action not definition
    CODE_1211 = 1211  # This trigger not definition
    CODE_1212 = 1212  # Action is empty
    CODE_1221 = 1221  # Ifttt execute failed
    CODE_1223 = 1223  # Ifttt same name
    CODE_1224 = 1224  # scene same name
    CODE_1226 = 1226  # Conditions of configuration is not correct
    CODE_1227 = 1227  # Conditions of configuration is not correct
    CODE_1228 = 1228  # Condition is repeated
    CODE_1229 = 1229  # Conditions of configuration is not correct
    CODE_1230 = 1230  # Action is repeated
    CODE_1231 = 1231  # Actions of configuration is not correct
    CODE_1232 = 1232  # Conditions and Actions of configuration is not correct
    CODE_1238 = 1238  # ifttt is abnormal
    CODE_1239 = 1239  # Conditions of configuration is not correct
    CODE_1300 = 1300  # The data is in operation
    CODE_2001 = 2001  # Get developer list error
    CODE_2002 = 2002  # Appid or Appkey illegal
    CODE_2003 = 2003  # AuthCode incorrect
    CODE_2004 = 2004  # AccessToken incorrect
    CODE_2005 = 2005  # AccessToken expired
    CODE_2006 = 2006  # RefreshToken incorrect
    CODE_2007 = 2007  # RefreshToken expired
    CODE_2008 = 2008  # Permission denied
    CODE_2009 = 2009  # Invalid OpenId
    CODE_2010 = 2010  # Unauthorized user
    CODE_2011 = 2011  # The query result is empty
    CODE_2012 = 2012  # Invalid apply
    CODE_2013 = 2013  # Developer Permission denied
    CODE_2014 = 2014  # Resource Permission denied
    CODE_2015 = 2015  # subscriber faild
    CODE_2016 = 2016  # AccountId has exist
    CODE_2017 = 2017  # Appkey exceeds the limit
    CODE_2018 = 2018  # IP config exceed the limit
    CODE_2022 = 2022  # Application not activated
